// 002 u_06_command_handler_client_10
// 22 mar 2010

// -- (C) John COLIBRI 2010
// -- documentation: http://www.jcolibri.com

(*$r+*)
unit u_06_command_handler_client_10;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, IdAntiFreezeBase, IdAntiFreeze, IdBaseComponent,
  IdComponent, IdTCPConnection, IdTCPClient;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    exit_: TButton;
    clear_: TButton;
    Splitter1: TSplitter;
    Memo1: TMemo;
    IdTCPClient1: TIdTCPClient;
    IdAntiFreeze1: TIdAntiFreeze;
    connect_: TButton;
    send_: TButton;
    Edit1: TEdit;
    readln_: TButton;
    quit_: TButton;
    disconnect_: TButton;
    send_date_string_: TButton;
    procedure IdTCPClient1Status(ASender: TObject; const AStatus: TIdStatus;
      const AStatusText: string);
    procedure IdTCPClient1Disconnected(Sender: TObject);
    procedure readln_Click(Sender: TObject);
    procedure send_Click(Sender: TObject);
    procedure connect_Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure close_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure IdTCPClient1Connected(Sender: TObject);
    procedure quit_Click(Sender: TObject);
    procedure disconnect_Click(Sender: TObject);
    procedure send_date_string_Click(Sender: TObject);
  private
  public
  end;

    var Form1: TForm1;

  implementation
    uses  u_c_log, u_c_display
        , IdGlobal
        ;

    {$R *.DFM}

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;
        Top:= 300;
        Left:= 100;
        Width:= 500;
      end; // FormCreate

    procedure TForm1.close_Click(Sender: TObject);
      begin
        Close;
      end; // close_Click

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    // -- actions

    procedure TForm1.connect_Click(Sender: TObject);
      var l_response: String;
      begin
        with IdTcpClient1 do
        begin
          display('> connect');
          Port:= 5678;

          display('=Connect');
          Connect;

          display('=Readln 200');
          // Read the welcome message
          GetResponse(200);
          display(LastCmdResult.Text.Text+ '%');

          display('< connect');
        end; // with ItTcpClient1
      end; // connect_Click

    procedure TForm1.IdTCPClient1Connected(Sender: TObject);
      begin
        display('after_connect');
      end; // IdTCPClient1Connected

    procedure TForm1.send_date_string_Click(Sender: TObject);
      begin
        display('> send_date_string_Click');
        IdTcpClient1.SendCmd('LA_DATE', 218);
        IdTcpClient1.IOHandler.Capture(Memo1.Lines);
        display('< send_date_string_Click');
      end; // send_date_string_Click

    // -- manual

    procedure TForm1.send_Click(Sender: TObject);
      begin
        display_line;
        display('> writeln_');
        IdTcpClient1.IoHandler.Writeln(Edit1.Text);
        display('< writeln_');
      end; // send_Click

    procedure TForm1.readln_Click(Sender: TObject);
      var l_response: String;
      begin
        display_line;
        display('> readln_');
        l_response:= IdTcpClient1.IoHandler.Readln;
        display(l_response);
        display('< readln_');
      end; // readln_Click

    procedure TForm1.quit_Click(Sender: TObject);
      begin
        display('> QUIT');
        IdTCPClient1.SendCmd('Quit', 202);
        display(IdTCPClient1.LastCmdResult.Text.Text+ '%');
        display('< QUIT');
      end; // quit_Click

    procedure TForm1.disconnect_Click(Sender: TObject);
      begin
        IdTCPClient1.Disconnect;
      end; // disconnect_Click

    procedure TForm1.IdTCPClient1Disconnected(Sender: TObject);
      begin
        display('did_disconnect');
      end; // IdTCPClient1Disconnected

    procedure TForm1.IdTCPClient1Status(ASender: TObject; const AStatus: TIdStatus;
        const AStatusText: string);
      begin
        display('status '+ aStatusText);
      end; // IdTCPClient1Status

    end.


