// 002 u_06_commandhandler_server_10
// 22 mar 2010

// -- (C) John COLIBRI 2010
// -- documentation: http://www.jcolibri.com

(*$r+*)
unit u_06_commandhandler_server_10;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, IdBaseComponent, IdComponent, IdTCPServer,
  IdCustomTCPServer, IdCmdTCPServer, IdCommandHandlers, IdContext;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    exit_: TButton;
    clear_: TButton;
    Splitter1: TSplitter;
    Memo1: TMemo;
    start_: TButton;
    stop_: TButton;
    IdCmdTCPServer1: TIdCmdTCPServer;
    procedure comand_handler_QUIT_comand(ASender: TIdCommand);
    procedure stop_Click(Sender: TObject);
    procedure start_Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure close_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure IdCmdTCPServer1BeforeCommandHandler(ASender: TIdCmdTCPServer;
      var AData: string; AContext: TIdContext);
    procedure IdCmdTCPServer1AfterCommandHandler(ASender: TIdCmdTCPServer;
      AContext: TIdContext);
    procedure IdCmdTCPServer1Connect(AContext: TIdContext);
    procedure IdCmdTCPServer1Status(ASender: TObject; const AStatus: TIdStatus;
      const AStatusText: string);
    procedure command_handler_LA_DATE_command(ASender: TIdCommand);
  private
  public
  end;

    var Form1: TForm1;

  implementation
    uses  u_c_log, u_c_display
        , IdGlobal
        ;

    {$R *.DFM}

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;
        Top:= 100;
        Left:= 200;
        Height:= 190;
        Width:= 500;
      end; // FormCreate

    procedure TForm1.close_Click(Sender: TObject);
      begin
        Close;
      end; // close_Click

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    procedure TForm1.start_Click(Sender: TObject);
      begin
        display('> start');
        IdCmdTcpServer1.DefaultPort:= 5678;

        IdCmdTcpServer1.Active:= True;
        display('< start');
      end; // start_Click

    procedure TForm1.IdCmdTCPServer1Connect(AContext: TIdContext);
      begin
        display_line;
        display('> IdTCPServer1Connect');
        display('client_did_connect');
        display('< IdTCPServer1Connect');
      end; // IdTCPServer1Connect

    procedure TForm1.IdCmdTCPServer1BeforeCommandHandler(ASender: TIdCmdTCPServer;
        var AData: string; AContext: TIdContext);
      begin
        display_line;
        display('IdCmdTCPServer1BeforeCommandHandler '+ aData+ '<');
      end; // IdCmdTCPServer1BeforeCommandHandler

    procedure TForm1.command_handler_LA_DATE_command(ASender: TIdCommand);
      begin
        ASender.Response.Add('the_date '+ DateToStr(Now));
        ASender.Response.Add('tomorrow '+ DateToStr(Now+ 1));
        ASender.Response.Add('in_a_weem '+ DateToStr(Now+ 7));
      end;

    procedure TForm1.comand_handler_QUIT_comand(ASender: TIdCommand);
      begin
        display('comand_handler_QUIT_comand');
        // ASender.PerformReply:= False;
      end; // comand_handler_QUIT_comand

    procedure TForm1.IdCmdTCPServer1AfterCommandHandler(ASender: TIdCmdTCPServer;
        AContext: TIdContext);
      begin
        display('IdCmdTCPServer1AfterCommandHandler');
      end; // IdCmdTCPServer1AfterCommandHandler

    procedure TForm1.stop_Click(Sender: TObject);
      begin
        display('> stop');
        IdCmdTcpServer1.Active:= False;
        display('< stop');
      end; // stop_Click

    procedure TForm1.IdCmdTCPServer1Status(ASender: TObject; const AStatus: TIdStatus;
        const AStatusText: string);
      begin
        display('status '+ aStatusText);
      end; // IdCmdTCPServer1Status


    end.


